//------------------------------------------------------------------------------
// <auto-generated>
//      Generated by NativeAssist version 1.0.0.0 with Split Generator.
//      Do not modify this file unless necessary.
// </auto-generated>
//------------------------------------------------------------------------------

namespace NativeFx.Interop;

using System;
using GTA.Native;
using GTA;
using GTA.Math;

public static partial class Natives 
{
public static class System {
/// <summary>
/// Pauses execution of the current script, please note this behavior is only seen when called from one of the game script files(ysc). In order to wait an asi script use &quot;static void WAIT(DWORD time);&quot; found in main.h
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> System<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x4EDE34FBADD967A6<br />
/// </para>
/// </remarks>
public static void Wait(int ms){
Function.Call((Hash)0x4EDE34FBADD967A6uL, ms);
}

/// <summary>
/// Examples:<br /> g_384A = SYSTEM::START_NEW_SCRIPT(&quot;cellphone_flashhand&quot;, 1424);<br /> l_10D = SYSTEM::START_NEW_SCRIPT(&quot;taxiService&quot;, 1828);<br /> SYSTEM::START_NEW_SCRIPT(&quot;AM_MP_YACHT&quot;, 5000);<br /> SYSTEM::START_NEW_SCRIPT(&quot;emergencycall&quot;, 512);<br /> SYSTEM::START_NEW_SCRIPT(&quot;emergencycall&quot;, 512); <br /> SYSTEM::START_NEW_SCRIPT(&quot;FM_maintain_cloud_header_data&quot;, 1424);<br /> SYSTEM::START_NEW_SCRIPT(&quot;FM_Mission_Controller&quot;, 31000);<br /> SYSTEM::START_NEW_SCRIPT(&quot;tennis_family&quot;, 3650);<br /> SYSTEM::START_NEW_SCRIPT(&quot;Celebrations&quot;, 3650);<br /><br />Decompiled examples of usage when starting a script:<br /> <br />    SCRIPT::REQUEST_SCRIPT(a_0);<br />    if (SCRIPT::HAS_SCRIPT_LOADED(a_0)) {<br />        SYSTEM::START_NEW_SCRIPT(a_0, v_3);<br />        SCRIPT::SET_SCRIPT_AS_NO_LONGER_NEEDED(a_0);<br />        return 1;<br />    }<br /> <br />or:<br /><br />    v_2 = &quot;MrsPhilips2&quot;;<br />    SCRIPT::REQUEST_SCRIPT(v_2);<br />    while (!SCRIPT::HAS_SCRIPT_LOADED(v_2)) {<br />    SCRIPT::REQUEST_SCRIPT(v_2);<br />    SYSTEM::WAIT(0);<br />    }<br />    sub_8792(36);<br />    SYSTEM::START_NEW_SCRIPT(v_2, 17000);<br />    SCRIPT::SET_SCRIPT_AS_NO_LONGER_NEEDED(v_2);
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> System<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xE81651AD79516E48<br />
/// </para>
/// </remarks>
public static int StartNewScript(string scriptName, int stackSize){
return Function.Call<int>((Hash)0xE81651AD79516E48uL, scriptName, stackSize);
}

/// <summary>
/// return : script thread id, 0 if failed<br />Pass pointer to struct of args in p1, size of struct goes into p2
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> System<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xB8BA7F44DF1575E1<br />
/// </para>
/// </remarks>
public static int StartNewScriptWithArgs(string scriptName, int /* bug: structure */ args, int argCount, int stackSize){
return Function.Call<int>((Hash)0xB8BA7F44DF1575E1uL, scriptName, args, argCount, stackSize);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> System<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xEB1C67C3A5333A92<br />
/// </para>
/// </remarks>
public static int StartNewScriptWithNameHash(uint scriptHash, int stackSize){
return Function.Call<int>((Hash)0xEB1C67C3A5333A92uL, scriptHash, stackSize);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> System<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xC4BB298BD441BE78<br />
/// </para>
/// </remarks>
public static int StartNewScriptWithNameHashAndArgs(uint scriptHash, int /* bug: structure */ args, int argCount, int stackSize){
return Function.Call<int>((Hash)0xC4BB298BD441BE78uL, scriptHash, args, argCount, stackSize);
}

/// <summary>
/// Counts up. Every 1000 is 1 real-time second. Use SETTIMERA(int value) to set the timer (e.g.: SETTIMERA(0)).
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> System<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x83666F9FB8FEBD4B<br />
/// </para>
/// </remarks>
public static int Timera(){
return Function.Call<int>((Hash)0x83666F9FB8FEBD4BuL);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> System<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xC9D9444186B5A374<br />
/// </para>
/// </remarks>
public static int Timerb(){
return Function.Call<int>((Hash)0xC9D9444186B5A374uL);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> System<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xC1B1E9A034A63A62<br />
/// </para>
/// </remarks>
public static void Settimera(int value){
Function.Call((Hash)0xC1B1E9A034A63A62uL, value);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> System<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x5AE11BC36633DE4E<br />
/// </para>
/// </remarks>
public static void Settimerb(int value){
Function.Call((Hash)0x5AE11BC36633DE4EuL, value);
}

/// <summary>
/// Gets the current frame time.
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> System<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x0000000050597EE2<br />
/// </para>
/// </remarks>
public static float Timestep(){
return Function.Call<float>((Hash)0x0000000050597EE2uL);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> System<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x0BADBFA3B172435F<br />
/// </para>
/// </remarks>
public static float Sin(float value){
return Function.Call<float>((Hash)0x0BADBFA3B172435FuL, value);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> System<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xD0FFB162F40A139C<br />
/// </para>
/// </remarks>
public static float Cos(float value){
return Function.Call<float>((Hash)0xD0FFB162F40A139CuL, value);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> System<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x71D93B57D07F9804<br />
/// </para>
/// </remarks>
public static float Sqrt(float value){
return Function.Call<float>((Hash)0x71D93B57D07F9804uL, value);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> System<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xE3621CC40F31FE2E<br />
/// </para>
/// </remarks>
public static float Pow(float @base, float exponent){
return Function.Call<float>((Hash)0xE3621CC40F31FE2EuL, @base, exponent);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> System<br />
/// <b>From Build:</b> 1493<br />
/// <b>Native ID:</b> 0xE816E655DE37FE20<br />
/// </para>
/// </remarks>
public static float Log10(float value){
return Function.Call<float>((Hash)0xE816E655DE37FE20uL, value);
}

/// <summary>
/// Calculates the magnitude of a vector.
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> System<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x652D2EEEF1D3E62C<br />
/// </para>
/// </remarks>
public static float Vmag(float x, float y, float z){
return Function.Call<float>((Hash)0x652D2EEEF1D3E62CuL, x, y, z);
}

/// <summary>
/// Calculates the magnitude of a vector but does not perform Sqrt operations. (Its way faster)
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> System<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xA8CEACB4F35AE058<br />
/// </para>
/// </remarks>
public static float Vmag2(float x, float y, float z){
return Function.Call<float>((Hash)0xA8CEACB4F35AE058uL, x, y, z);
}

/// <summary>
/// Calculates distance between vectors.
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> System<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x2A488C176D52CCA5<br />
/// </para>
/// </remarks>
public static float Vdist(float x1, float y1, float z1, float x2, float y2, float z2){
return Function.Call<float>((Hash)0x2A488C176D52CCA5uL, x1, y1, z1, x2, y2, z2);
}

/// <summary>
/// Calculates distance between vectors but does not perform Sqrt operations. (Its way faster)
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> System<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xB7A628320EFF8E47<br />
/// </para>
/// </remarks>
public static float Vdist2(float x1, float y1, float z1, float x2, float y2, float z2){
return Function.Call<float>((Hash)0xB7A628320EFF8E47uL, x1, y1, z1, x2, y2, z2);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> System<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xEDD95A39E5544DE8<br />
/// </para>
/// </remarks>
public static int ShiftLeft(int value, int bitShift){
return Function.Call<int>((Hash)0xEDD95A39E5544DE8uL, value, bitShift);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> System<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x97EF1E5BCE9DC075<br />
/// </para>
/// </remarks>
public static int ShiftRight(int value, int bitShift){
return Function.Call<int>((Hash)0x97EF1E5BCE9DC075uL, value, bitShift);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> System<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xF34EE736CF047844<br />
/// </para>
/// </remarks>
public static int Floor(float value){
return Function.Call<int>((Hash)0xF34EE736CF047844uL, value);
}

/// <summary>
/// I&apos;m guessing this rounds a float value up to the next whole number, and FLOOR rounds it down
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> System<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0x11E019C8F43ACC8A<br />
/// </para>
/// </remarks>
public static int Ceil(float value){
return Function.Call<int>((Hash)0x11E019C8F43ACC8AuL, value);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> System<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xF2DB717A73826179<br />
/// </para>
/// </remarks>
public static int Round(float value){
return Function.Call<int>((Hash)0xF2DB717A73826179uL, value);
}

/// <summary>
/// <i>No description available.</i>
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> System<br />
/// <b>From Build:</b> 323<br />
/// <b>Native ID:</b> 0xBBDA792448DB5A89<br />
/// </para>
/// </remarks>
public static float ToFloat(int value){
return Function.Call<float>((Hash)0xBBDA792448DB5A89uL, value);
}

/// <summary>
/// THREAD_PRIO_HIGHEST = 0<br />THREAD_PRIO_NORMAL = 1<br />THREAD_PRIO_LOWEST = 2<br />THREAD_PRIO_MANUAL_UPDATE = 100
/// </summary>
/// <remarks>
/// <para>
/// <b>In Namespace:</b> System<br />
/// <b>From Build:</b> 877<br />
/// <b>Native ID:</b> 0x42B65DEEF2EDF2A1<br />
/// </para>
/// </remarks>
public static void SetThisThreadPriority(int priority){
Function.Call((Hash)0x42B65DEEF2EDF2A1uL, priority);
}

}}
